Am Pakfire weitergearbeitet.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0t4" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 #ipfiremake linux XEN=1
340 ipfiremake linux
341 ipfiremake ipp2p
342 ipfiremake fcdsl
343 ipfiremake fcdsl2
344 ipfiremake fcdslsl
345 ipfiremake fcdslusb
346 ipfiremake fcdslslusb
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake klibc
353 ipfiremake mkinitcpio
354 ipfiremake udev KLIBC=1
355 ipfiremake expat
356 ipfiremake gdbm
357 ipfiremake gmp
358 ipfiremake pam
359 ipfiremake openssl
360 ipfiremake python
361 ipfiremake libnet
362 ipfiremake libjpeg
363 ipfiremake libpng
364 ipfiremake libtiff
365 ipfiremake libart
366 ipfiremake freetype
367 ipfiremake gd
368 ipfiremake popt
369 ipfiremake pcre
370 ipfiremake slang
371 ipfiremake newt
372 ipfiremake libcap
373 ipfiremake pciutils
374 ipfiremake libxml2
375 ipfiremake libxslt
376 ipfiremake BerkeleyDB
377 ipfiremake mysql
378 ipfiremake cyrus-sasl
379 ipfiremake openldap
380 ipfiremake apache2
381 ipfiremake php
382 ipfiremake apache2 PASS=C
383 ipfiremake arping
384 ipfiremake beep
385 ipfiremake bind
386 ipfiremake capi4k-utils
387 ipfiremake cdrtools
388 ipfiremake dnsmasq
389 ipfiremake dosfstools
390 ipfiremake reiserfsprogs
391 ipfiremake squashfstools
392 ipfiremake sysfsutils
393 ipfiremake ntfs-3g
394 ipfiremake ethtool
395 ipfiremake ez-ipupdate
396 ipfiremake fcron
397 ipfiremake GD
398 ipfiremake GD-Graph
399 ipfiremake GD-TextUtil
400 ipfiremake gnupg
401 ipfiremake hdparm
402 ipfiremake ibod
403 ipfiremake initscripts
404 ipfiremake whatmask
405 ipfiremake iptables
406 ipfiremake libupnp
407 ipfiremake ipp2p IPT=1
408 ipfiremake moblock
409 ipfiremake linux-igd
410 ipfiremake ipac-ng
411 ipfiremake ipaddr
412 ipfiremake iptstate
413 ipfiremake iputils
414 ipfiremake l7-protocols
415 ipfiremake isdn4k-utils
416 ipfiremake mISDN
417 ipfiremake hwdata
418 ipfiremake kudzu
419 ipfiremake logrotate
420 ipfiremake logwatch
421 ipfiremake misc-progs
422 ipfiremake mtools
423 ipfiremake nano
424 ipfiremake nasm
425 ipfiremake URI
426 ipfiremake HTML-Tagset
427 ipfiremake HTML-Parser
428 ipfiremake Compress-Zlib
429 ipfiremake Digest
430 ipfiremake Digest-SHA1
431 ipfiremake Digest-HMAC
432 ipfiremake libwww-perl
433 ipfiremake Net-DNS
434 ipfiremake Net-IPv4Addr
435 ipfiremake Net_SSLeay
436 ipfiremake IO-Stringy
437 ipfiremake Unix-Syslog
438 ipfiremake Mail-Tools
439 ipfiremake MIME-Tools
440 ipfiremake Net-Server
441 ipfiremake Convert-TNEF
442 ipfiremake Convert-UUlib
443 ipfiremake Archive-Tar
444 ipfiremake Archive-Zip
445 ipfiremake Text-Tabs+Wrap
446 ipfiremake Locale-Country
447 ipfiremake XML-Parser
448 ipfiremake glib
449 ipfiremake GeoIP
450 ipfiremake fwhits
451 ipfiremake noip_updater
452 ipfiremake ntp
453 ipfiremake openssh
454 ipfiremake openswan
455 ipfiremake pptpclient
456 ipfiremake rrdtool
457 ipfiremake setserial
458 ipfiremake setup
459 ipfiremake snort
460 ipfiremake snortsnarf
461 ipfiremake oinkmaster
462 ipfiremake squid
463 ipfiremake squid-graph
464 ipfiremake squidguard
465 ipfiremake calamaris
466 ipfiremake tcpdump
467 ipfiremake traceroute
468 ipfiremake vlan
469 ipfiremake wireless
470 ipfiremake libsafe
471 ipfiremake 3c5x9setup
472 ipfiremake pakfire
473 ipfiremake java
474 ipfiremake spandsp
475 ipfiremake lzo
476 ipfiremake openvpn
477 ipfiremake pammysql
478 ipfiremake ghostscript
479 ipfiremake cups
480 ipfiremake samba
481 ipfiremake sudo
482 ipfiremake mc
483 ipfiremake wget
484 ipfiremake bridge-utils
485 ipfiremake screen
486 ipfiremake hddtemp
487 ipfiremake smartmontools
488 ipfiremake htop
489 ipfiremake postfix
490 ipfiremake fetchmail
491 ipfiremake cyrusimap
492 ipfiremake webcyradm
493 ipfiremake mailx
494 ipfiremake clamav
495 ipfiremake spamassassin
496 ipfiremake amavisd
497 ipfiremake stund
498 ipfiremake libpri
499 # ipfiremake bristuff
500 ipfiremake asterisk
501 ipfiremake mpg123
502 ipfiremake libmad
503 ipfiremake libogg
504 ipfiremake libvorbis
505 ipfiremake lame
506 ipfiremake sox
507 ipfiremake gnump3d
508 ipfiremake applejuice
509 ipfiremake ocaml
510 ipfiremake mldonkey
511 ipfiremake rsync
512 ipfiremake tcpwrapper
513 ipfiremake portmap
514 ipfiremake nfs
515 ipfiremake nmap
516 ipfiremake mbmon
517 ipfiremake iftop
518 ipfiremake ncftp
519 ipfiremake cftp
520 ipfiremake etherwake
521 ipfiremake ethereal
522 ipfiremake tftp-hpa
523 ipfiremake bwm-ng
524 ipfiremake tripwire
525 ipfiremake sysstat
526 ipfiremake vsftpd
527 ipfiremake alsa
528 ipfiremake mp3blaster
529 }
530
531 buildinstaller() {
532 # Run installer scripts one by one
533 LOGFILE="$BASEDIR/log/_build.installer.log"
534 export LOGFILE
535 ipfiremake syslinux
536 ipfiremake as86
537 ipfiremake mbr
538 ipfiremake memtest
539 installmake linux-libc-header
540 installmake binutils
541 ipfiremake uClibc PASS=1
542 ipfiremake gcc INST=1
543 installmake uClibc PASS=2
544 installmake gcc INST=2
545 installmake uClibc PASS=3
546 installmake busybox
547 installmake udev
548 installmake slang
549 installmake newt
550 installmake gettext
551 installmake kbd
552 installmake popt
553 installmake sysvinit
554 installmake misc-progs
555 installmake e2fsprogs
556 installmake libaal
557 installmake reiser4progs
558 installmake reiserfsprogs
559 installmake sysfsutils
560 installmake util-linux
561 installmake pciutils
562 installmake zlib
563 installmake mtd
564 installmake wget
565 installmake hwdata
566 installmake kudzu
567 installmake installer
568 installmake initrd
569 }
570
571 buildpackages() {
572 LOGFILE="$BASEDIR/log/_build.packages.log"
573 export LOGFILE
574 echo "... see detailed log in _build.*.log files" >> $LOGFILE
575
576 installmake strip
577
578 # Generating list of packages used
579 echo -n "Generating packages list from logs" | tee -a $LOGFILE
580 rm -f $BASEDIR/doc/packages-list
581 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
582 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
583 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
584 fi
585 done
586 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
587 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
588 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
589 rm -f $BASEDIR/doc/packages-list
590 # packages-list.txt is ready to be displayed for wiki page
591 beautify message DONE
592
593 # Create images for install
594 if [ "$DEVEL" == "1" ]; then
595 ipfiremake cdrom ED=devel
596 fi
597 ipfiremake cdrom ED=full
598
599 # Check if there is a loop device for building in virtual environments
600 if [ -e /dev/loop0 ]; then
601 ipfiremake usb-stick
602 fi
603 ipfiremake pxe
604 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
605
606 ipfirepackages
607
608 # Cleanup
609 stdumount
610 rm -rf $BASEDIR/build/tmp/*
611
612 # Generating total list of files
613 echo -n "Generating files list from logs" | tee -a $LOGFILE
614 rm -f $BASEDIR/log/FILES
615 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
616 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
617 echo "##" >>$BASEDIR/log/FILES
618 echo "## `basename $i`" >>$BASEDIR/log/FILES
619 echo "##" >>$BASEDIR/log/FILES
620 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
621 fi
622 done
623 beautify message DONE
624
625 cd $PWD
626 }
627
628 ipfirepackages() {
629 ipfiredist alsa
630 # ipfiredist amavisd
631 # ipfiredist applejuice
632 # ipfiredist asterisk
633 ipfiredist clamav
634 ipfiredist cups
635 ipfiredist cyrus-sasl
636 # ipfiredist fetchmail
637 # ipfiredist gnump3d
638 # ipfiredist java
639 ipfiredist libogg
640 ipfiredist libvorbis
641 # ipfiredist mailx
642 # ipfiredist mldonkey
643 ipfiredist mp3blaster
644 ipfiredist mpg123
645 # ipfiredist nfs
646 ipfiredist openldap
647 # ipfiredist postfix
648 ipfiredist samba
649 # ipfiredist sox
650 # ipfiredist spamassassin
651 ipfiredist tripwire
652 ipfiredist vsftpd
653 # ipfiredist webcyradm
654 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
655 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
656 rm -rf $BASEDIR/build/install/packages/*
657 }
658
659 # See what we're supposed to do
660 case "$1" in
661 build)
662 clear
663 BUILDMACHINE=`uname -m`
664 DEVEL=0
665 if [ "$2" == "--devel" ]; then
666 DEVEL=1
667 fi
668 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
669 #only restore on a clean disk
670 if [ ! -f log/cleanup-toolchain-2-tools ]; then
671 if [ ! -n "$PACKAGE" ]; then
672 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
673 prepareenv
674 buildtoolchain
675 else
676 PACKAGENAME=${PACKAGE%.tar.gz}
677 beautify build_stage "Packaged toolchain compilation"
678 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
679 tar zxf $PACKAGE
680 prepareenv
681 else
682 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
683 fi
684 fi
685 else
686 echo -n "Using installed toolchain" | tee -a $LOGFILE
687 beautify message SKIP
688 prepareenv
689 fi
690
691 beautify build_start
692 beautify build_stage "Building LFS"
693 buildbase
694
695 beautify build_stage "Building IPFire"
696 buildipfire
697
698 # Setzen des IPFire Builds
699 if [ "$FIREBUILD" ]; then
700 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
701 else
702 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
703 fi
704
705 beautify build_stage "Building installer"
706 buildinstaller
707
708 beautify build_stage "Building packages"
709 buildpackages
710 beautify build_end
711 ;;
712 shell)
713 # enter a shell inside LFS chroot
714 # may be used to changed kernel settings
715 prepareenv
716 entershell
717 ;;
718 changelog)
719 echo -n "Loading new Changelog from SVN: "
720 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
721 beautify message DONE
722 ;;
723 clean)
724 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
725 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
726 $LOSETUP -d $i 2>/dev/null
727 done
728 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
729 umount $i
730 done
731 stdumount
732 for i in `seq 0 7`; do
733 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
734 umount /dev/loop${i} 2>/dev/null;
735 losetup -d /dev/loop${i} 2>/dev/null;
736 fi;
737 done
738 rm -rf $BASEDIR/build
739 rm -rf $BASEDIR/cdrom
740 rm -rf $BASEDIR/packages
741 rm -rf $BASEDIR/log
742 if [ -h /tools ]; then
743 rm -f /tools
744 fi
745 beautify message DONE
746 ;;
747 downloadsrc)
748 if [ ! -d $BASEDIR/cache ]; then
749 mkdir $BASEDIR/cache
750 fi
751 mkdir -p $BASEDIR/log
752 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
753 FINISHED=0
754 cd $BASEDIR/lfs
755 for c in `seq $MAX_RETRIES`; do
756 if (( FINISHED==1 )); then
757 break
758 fi
759 FINISHED=1
760 cd $BASEDIR/lfs
761 for i in *; do
762 if [ -f "$i" -a "$i" != "Config" ]; then
763 echo -ne "Loading $i"
764 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
765 if [ $? -ne 0 ]; then
766 beautify message FAIL
767 FINISHED=0
768 else
769 if [ $c -eq 1 ]; then
770 beautify message DONE
771 fi
772 fi
773 fi
774 done
775 done
776 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
777 ERROR=0
778 for i in *; do
779 if [ -f "$i" -a "$i" != "Config" ]; then
780 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
781 if [ $? -ne 0 ]; then
782 echo -ne "MD5 difference in lfs/$i"
783 beautify message FAIL
784 ERROR=1
785 fi
786 fi
787 done
788 if [ $ERROR -eq 0 ]; then
789 echo -ne "${BOLD}all files md5sum match${NORMAL}"
790 beautify message DONE
791 else
792 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
793 beautify message FAIL
794 fi
795 cd - >/dev/null 2>&1
796 ;;
797 toolchain)
798 clear
799 prepareenv
800 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
801 buildtoolchain
802 BUILDMACHINE=`uname -m`
803 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
804 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
805 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
806 build/{bin,etc,usr/bin,usr/local} \
807 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
808 log >> $LOGFILE
809 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
810 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
811 stdumount
812 ;;
813 gettoolchain)
814 BUILDMACHINE=`uname -m`
815 # arbitrary name to be updated in case of new toolchain package upload
816 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
817 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
818 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
819 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
820 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
821 cd $BASEDIR/cache/toolchains
822 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
823 if [ $? -ne 0 ]; then
824 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
825 else
826 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
827 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
828 else
829 exiterror "$PACKAGE.md5 did not match, check downloaded package"
830 fi
831 fi
832 else
833 echo "Toolchain is already downloaded. Exiting..."
834 fi
835 ;;
836 othersrc)
837 prepareenv
838 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
839 chroot $LFS /tools/bin/env -i HOME=/root \
840 TERM=$TERM PS1='\u:\w\$ ' \
841 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
842 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
843 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
844 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
845 if [ $? -eq "0" ]; then
846 beautify message DONE
847 else
848 beautify message FAIL
849 fi
850 stdumount
851 ;;
852 svn)
853 case "$2" in
854 update|up)
855 # clear
856 echo -ne "Loading the latest source files...\n"
857 if [ $3 ]; then
858 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
859 else
860 svn update | tee -a $PWD/log/_build.svn.update.log
861 fi
862 if [ $? -eq "0" ]; then
863 beautify message DONE
864 else
865 beautify message FAIL
866 exit 1
867 fi
868 echo -ne "Writing the svn-info to a file"
869 svn info > $PWD/svn_status
870 if [ $? -eq "0" ]; then
871 beautify message DONE
872 else
873 beautify message FAIL
874 exit 1
875 fi
876 chmod 755 $0
877 exit 0
878 ;;
879 commit|ci)
880 clear
881 if [ -f /usr/bin/mcedit ]; then
882 export EDITOR=/usr/bin/mcedit
883 fi
884 if [ -f /usr/bin/nano ]; then
885 export EDITOR=/usr/bin/nano
886 fi
887 echo -ne "Selecting editor $EDITOR..."
888 beautify message DONE
889 if [ -e /sbin/yast ]; then
890 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
891 $0 changelog
892 fi
893 fi
894 update_langs
895 svn commit
896 $0 svn up
897 if [ -n "$FTP_CACHE_URL" ]; then
898 $0 uploadsrc
899 fi
900 ;;
901 dist)
902 if [ $3 ]; then
903 SVN_REVISION=$3
904 fi
905 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
906 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
907 exit 0
908 fi
909 echo -en "REV $SVN_REVISION: Downloading..."
910 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
911 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
912 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
913 evaluate 1
914
915 echo -en "REV $SVN_REVISION: Compressing files..."
916 if [ -e ipfire-source/trunk/make.sh ]; then
917 chmod 755 ipfire-source/trunk/make.sh
918 fi
919 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
920 evaluate 1
921 echo -en "REV $SVN_REVISION: Cleaning up..."
922 rm ipfire-source/ -r
923 evaluate 1
924 ;;
925 diff|di)
926 update_langs
927 echo -ne "Make a local diff to last svn revision"
928 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
929 evaluate 1
930 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
931 svn status
932 ;;
933 esac
934 ;;
935 uploadsrc)
936 PWD=`pwd`
937 cd $BASEDIR/cache/
938 echo -e "Uploading cache to ftp server:"
939 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
940 for i in *; do
941 if [ "$i" == "toolchains" ]; then continue; fi
942 grep -q $i /tmp/ftplist
943 if [ "$?" -ne "0" ]; then
944 echo -ne "$i"
945 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
946 if [ "$?" -ne "0" ]; then
947 beautify message FAIL
948 fi
949 fi
950 done
951 rm -f /tmp/ftplist
952 cd $PWD
953 exit 0
954 ;;
955 upload)
956 case "$2" in
957 iso)
958 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
959 cat <<EOF > .ftp-commands
960 mkdir -p $FTP_ISO_PATH$SVN_REVISION
961 ls -lah
962 quit
963 EOF
964 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
965 rm -f .ftp-commands
966 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
967 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
968 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
969 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
970 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
971 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
972 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
973 fi
974 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
975 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
976 if [ "$?" -eq "0" ]; then
977 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
978 else
979 echo -e "There was an error while uploading the iso to the ftp server."
980 exit 1
981 fi
982 if [ "$3" = "--with-sources-cd" ]; then
983 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
984 fi
985 ;;
986 paks)
987 cat <<EOF > .ftp-commands
988 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
989 ls -lah
990 quit
991 EOF
992 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
993 rm -f .ftp-commands
994 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
995 if [ "$?" -eq "0" ]; then
996 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
997 else
998 echo -e "There was an error while uploading the packages to the ftp server."
999 exit 1
1000 fi
1001 ;;
1002 esac
1003 ;;
1004 batch)
1005 if [ "$2" = "--background" ]; then
1006 batch_script
1007 exit $?
1008 fi
1009 if [ `screen -ls | grep -q ipfire` ]; then
1010 echo "Build is already running, sorry!"
1011 exit 1
1012 else
1013 if [ "$2" = "--rebuild" ]; then
1014 export IPFIRE_REBUILD=1
1015 echo "REBUILD!"
1016 else
1017 export IPFIRE_REBUILD=0
1018 fi
1019 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1020 screen -dmS ipfire $0 batch --background
1021 evaluate 1
1022 exit 0
1023 fi
1024 ;;
1025 watch)
1026 watch_screen
1027 ;;
1028 pxe)
1029 case "$2" in
1030 start)
1031 start_tftpd
1032 ;;
1033 stop)
1034 stop_tftpd
1035 ;;
1036 reload|restart)
1037 reload_tftpd
1038 ;;
1039 esac
1040 exit 0
1041 ;;
1042 lang)
1043 update_langs
1044 ;;
1045 packages)
1046 case "$2" in
1047 sign)
1048 sign_packages
1049 ;;
1050 esac
1051 ;;
1052 "")
1053 clear
1054 svn info
1055 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1056 do
1057 case $name in
1058 "IPFIRE: Downloadsrc")
1059 $0 downloadsrc
1060 ;;
1061 "IPFIRE: Build (silent)")
1062 $0 build-silent
1063 ;;
1064 "IPFIRE: Watch Build")
1065 $0 watch
1066 ;;
1067 "IPFIRE: Batch")
1068 $0 batch
1069 ;;
1070 "IPFIRE: Clean")
1071 $0 clean
1072 ;;
1073 "SVN: Update")
1074 $0 svn update
1075 ;;
1076 "Help")
1077 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1078 cat doc/make.sh-usage
1079 ;;
1080 "LOG: Tail")
1081 tail -f log/_*
1082 ;;
1083 "Exit")
1084 break
1085 ;;
1086 esac
1087 done
1088 ;;
1089 config)
1090 make_config
1091 ;;
1092 *)
1093 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1094 cat doc/make.sh-usage
1095 ;;
1096 esac